Subject: Re: [PATCH 2/2] core.fsyncobjectfiles: batch disk flushes

From: Christoph Hellwig <[email-masked]>
Date: Thu, 26 Aug 2021 07:54:39 +0200

On Wed, Aug 25, 2021 at 10:40:53AM -0700, Neeraj Singh wrote:
> I'd expect syncfs to suffer from the noisy-neighbor problem that Linus
> alluded to on the big
> thread you kicked off.

It does.  That being said I suspect in most developer workstation
use cases it will still be a win.  Maybe I'll look into implemeting
it after your series lands.

> If someone adds a more targeted bulk sync interface to the Linux
> kernel, I'm sure Git could be
> changed to use it. Maybe an fcntl(2) interface that initiates
> writeback and registers completion with an
> eventfd.

That is in general very hard to do with how the VM-level writeback
occurs.  In the file system itself it could work much better, e.g.
for XFS we write the log up to a specific sequence number and could
notify when doing that.